var userID;
var contentXML;

function setup() {
    createGenericButton(document.getElementById("donePrefsButton"),"Done",performDone,60)
    document.getElementById("donePrefsButton").style.display = "none";
    // put your setup code here...
    if (window.widget) {
	document.getElementById("userName").value = widget.preferenceForKey('userName');
    }

    //alert(document.getElementById("userName").value);

    replaceContent();
}

function getUserID() {
    var match;
    if (document.getElementById("userName").value == "undefined") return;

    /* fetch page */
    var req = new XMLHttpRequest();
    var testURL = "http://upcoming.org/search/?scope=allmetros&type=Users&q="+ document.getElementById("userName").value +"&Search=Search";
    req.open("GET", testURL, false);
    req.setRequestHeader("Cache-Control", "no-cache");
    req.onreadystatechange = function() {
	if (req.readyState == 4) {
	    if (req.status == 200) {
		pageContent = req.responseText;
		//alert(pageContent);
		var matchesArray = pageContent.match(/<a href="?.\/user\/([0-9]+)/g);
		match = matchesArray[0].replace(/<a href="?.\/user\//g, '');
		//alert("USER ID =");
	    }
	}
    }
    req.send(null);

    alert("getUserID=" + req.statusText);
    alert(document.getElementById("userName").value +" = "+ match);
    return match;
}

function usernameKeyPress(event) {
    switch (event.keyCode) {
	case 13:    // return
	case 3: // enter
	    performDone();
	break;
	default:
	    //alert(event.keyCode);
	    break;
    }
}

function replaceContent() {
    userID = getUserID();

    if (userID == "undefined" || userID == null) {
	upcomingEvents.innerHTML = "Please enter your username on the flip side";
	document.getElementById("upb_more").style.visibility = "hidden";
	return;
    } else {
	document.getElementById("upb_more").style.visibility = "visible";
	window.resizeTo(162,400);
    }

    var rebuildData = "";

    var req = new XMLHttpRequest();
    req.open("GET", 'http://upcoming.org/services/rest/?api_key=ce10079f87&username=upcomingwidget&%70%61%73%73%77%6F%72%64=%64%61%73%68%62%30%61%72%64&method=user.getWatchlist&user_id='+ userID, false);
    req.setRequestHeader("Cache-Control", "no-cache");
    req.onreadystatechange = function() {
	if (req.readyState == 4) {
	    if (req.status == 200) {
		//alert("NEW SCRIPT =");
		response  = req.responseXML;
		var events = response.getElementsByTagName("event");

		maxEvents = (events.length > 5 ? 5 : events.length);
		var olddate = "";
		for (var i = 0; i < maxEvents; i++) {
		    if (olddate != events[i].start_date) {
			rebuildData += formatDate(events[i].start_date);
		    } else {
			//rebuildData += "<br />";
		    }
		    olddate = events[i].start_date;
		    rebuildData += formatEvent(events[i].name, events[i].id);
		    rebuildData += formatVenue(events[i].venue_name, events[i].venue_id);
		    //alert(rebuildData);
		}
	    }
	    alert("replaceContent=" + req.statusText);
	}
    }
    req.send(null);

    document.getElementById("userNameDisplay").innerHTML = document.getElementById("userName").value;
    upcomingEvents.innerHTML = rebuildData;
    externalLinks();
}

function formatDate(d) {
    var dateArray = d.split("-");
    var months = new Array("January ", "February ", "March ", "April ", "May ", "June ", "July ", "August ", "September ", "October ", "November ", "December ");
    return '<div class="upb_date"><span class="upb_text">'+ months[dateArray[1]-1] + dateArray[2] +'</span></div>';
}

function formatEvent(ename, id) {
    return '<div class="upb_event" id="upcoming_badge_1"><span class="upb_title upb_text"><a href="http://upcoming.org/event/'+ id +'/">'+ ename +'</a></span> ';
}

function formatVenue(vname, vid) {
    return ' <span class="upb_venue upb_text">@ <a href="http://upcoming.org/venue/'+ vid +'/">'+ vname +'</a></span></div>';
}

function performDone() {
    if (window.widget) widget.setPreferenceForKey(document.getElementById("userName").value, 'userName');
    replaceContent();
    hidePrefs();
}

// everything below here handles showing and flipping to the prefs on the back and back again...
function showPrefs() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget)
    widget.prepareForTransition("ToBack");

    if (document.getElementById("userName").value == "undefined") {
	document.getElementById("userName").value = "";
	document.prefsForm.userName.focus();
    }

    front.style.display="none";
    back.style.display="block";
    document.getElementById("donePrefsButton").style.display = "block";

    if (window.widget)
	setTimeout ('widget.performTransition();', 0);
}

function hidePrefs() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget)
	widget.prepareForTransition("ToFront");

    back.style.display="none";
    document.getElementById("donePrefsButton").style.display = "none";
    front.style.display="block";

    if (window.widget)
	setTimeout ('widget.performTransition();', 0);
}

function enterflip(event) {
    document.getElementById('fliprollie').style.display = 'block';
}
function exitflip(event) {
    document.getElementById('fliprollie').style.display = 'none';
}

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
function mousemove (event) {
    if (!flipShown) {
	if (animation.timer != null)
	{
	    clearInterval (animation.timer);
	    animation.timer  = null;
	}

	var starttime = (new Date).getTime() - 13;

	animation.duration = 500;
	animation.starttime = starttime;
	animation.firstElement = document.getElementById ('flip');
	animation.timer = setInterval ("animate();", 13);
	animation.from = animation.now;
	animation.to = 1.0;
	animate();
	flipShown = true;
    }
}
function mouseexit (event) {
    if (flipShown) {
	// fade in the info button
	if (animation.timer != null) {
	    clearInterval (animation.timer);
	    animation.timer  = null;
	}

	var starttime = (new Date).getTime() - 13;

	animation.duration = 500;
	animation.starttime = starttime;
	animation.firstElement = document.getElementById ('flip');
	animation.timer = setInterval ("animate();", 13);
	animation.from = animation.now;
	animation.to = 0.0;
	animate();
	flipShown = false;
    }
}
function animate() {
    var T;
    var ease;
    var time = (new Date).getTime();


    T = limit_3(time-animation.starttime, 0, animation.duration);

    if (T >= animation.duration)
    {
	clearInterval (animation.timer);
	animation.timer = null;
	animation.now = animation.to;
    }
    else
    {
	ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
	animation.now = computeNextFloat (animation.from, animation.to, ease);
    }

    animation.firstElement.style.opacity = animation.now;
}
function limit_3 (a, b, c) {
    return a < b ? b : (a > c ? c : a);
}
function computeNextFloat (from, to, ease) {
    return from + (to - from) * ease;
}

function externalLinks() {
	if (!document.getElementsByTagName) return;
    var anchors = document.getElementsByTagName("a");
    var oldanchor = "";

    for (var i=0; i<anchors.length; i++) {
	var anchor = anchors[i];
	if (anchor.getAttribute("href")) {
	    oldanchor = anchor.href;
	    anchor.href = "javascript:openLinkInBrowser('" + oldanchor + "')";
	}
    }
}

function openLinkInBrowser(url) {
    if (window.widget) {
	widget.openURL(url);
    } else {
	window.open(url);
    }
}